"""Add roles and bucket limits

Revision ID: 68d3a8de7eba
Revises: a2194d0723b8
Create Date: 2024-04-18 10:26:33.808270

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

from clowmdb.db.base_class import uuid7

# revision identifiers, used by Alembic.
revision = "68d3a8de7eba"
down_revision = "a2194d0723b8"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "role",
        sa.Column("role_id", sa.BINARY(length=16), nullable=False),
        sa.Column("name", sa.String(length=64), nullable=False),
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column("updated_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.PrimaryKeyConstraint("role_id"),
    )
    op.create_index(op.f("ix_role_role_id"), "role", ["role_id"], unique=True)
    op.create_table(
        "user_role_mapping",
        sa.Column("uid", sa.BINARY(length=16), nullable=False),
        sa.Column("role_id", sa.BINARY(length=16), nullable=False),
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column("updated_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.ForeignKeyConstraint(["role_id"], ["role.role_id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["uid"], ["user.uid"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("uid", "role_id"),
    )
    op.add_column("bucket", sa.Column("size_limit", mysql.INTEGER(unsigned=True), nullable=True))
    op.add_column("bucket", sa.Column("object_limit", mysql.INTEGER(unsigned=True), nullable=True))
    op.drop_column("bucket", "owner_constraint")
    op.add_column("user", sa.Column("initialized", sa.Boolean(), nullable=False))

    # Insert roles into database
    op.get_bind().execute(
        sa.sql.text(
            f"""
    INSERT INTO role (role_id, name) VALUES
    (0x{uuid7().hex.upper()}, 'administrator'),
    (0x{uuid7().hex.upper()}, 'user'),
    (0x{uuid7().hex.upper()}, 'reviewer'),
    (0x{uuid7().hex.upper()}, 'developer'),
    (0x{uuid7().hex.upper()}, 'db_maintainer')
    """
        )
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("user", "initialized")
    op.add_column("bucket", sa.Column("owner_constraint", mysql.ENUM("READ", "WRITE"), nullable=True))
    op.drop_column("bucket", "object_limit")
    op.drop_column("bucket", "size_limit")
    op.drop_table("user_role_mapping")
    op.drop_index(op.f("ix_role_role_id"), table_name="role")
    op.drop_table("role")
    # ### end Alembic commands ###
